
data Peano = Zero | Succ Peano
               deriving (Eq, Ord, Show)

instance Num Peano where
    Zero   + m            = m
    Succ n + m            = n + Succ m

    n      - Zero         = n
    Succ n - Succ m       = n - m
    Zero   - m            = error "Peano.(-): negative number"

    abs                   = id
    signum Zero           = 0 -- a Haskell vlasza mgis Zero lesz!
    signum n              = 1 -- erre meg Succ Zero!  Magyarzd meg!

    fromInteger 0         = Zero
    fromInteger n | n > 0 = Succ (fromInteger (n-1))

instance Real Peano where
    toRational            = toRational . toInteger

instance Enum Peano where
    succ n                = Succ n

    pred  Zero            = error "Peano.pred: negative number"
    pred (Succ n)         = n

    toEnum                = fromInteger . toInteger
    fromEnum              = fromInteger . toInteger

instance Integral Peano where
    n `quotRem` Zero      = error "Peano.quotRem: division by zero"
    n `quotRem` d         = qR n d Zero n
	where qR  Zero     Zero    q r = (Succ q, Zero)
	      qR  Zero     d       q r = (q, r)
	      qR  n        Zero    q r = qR n d (Succ q) n
	      qR (Succ n) (Succ d) q r = qR n d q r

    toInteger Zero        = 0
    toInteger (Succ n)    = 1 + toInteger n

-- let x = (fromInteger 7 ::Peano) `quotRem` (fromInteger 3 ::Peano) in (toInteger(fst x), toInteger(snd x))
